<template>
  <div class="form-group" :class="{ invalid: invalid && !isTouched }">
    <label :for="id" v-text="label" class="form-label"></label>
    <input
      :id="id"
      :type="type"
      :value="value"
      class="form-input"
      @input="$emit('input', $event.target.value)"
      @change="$emit('change', $event.target.value)"
      @focusout="$emit('focusout', $event.target.value)"
    />
  </div>
</template>

<script>
export default {
  name: "VInput",
  props: {
    type: {
      type: String,
      default: "text"
    },
    value: {
      type: [String, Number],
      default: ""
    },
    label: {
      type: String,
      default: ""
    },
    invalid: {
      type: Boolean,
      default: false
    },
    isTouched: {
      type: Boolean,
      default: false
    }
  },
  data: () => ({
    id: Math.random()
      .toString(16)
      .substr(2)
  })
};
</script>

<style scoped>
.invalid {
  color: red;
}
</style>
